<?php
/**
 *
 *
 * @version Ipayment 2.0  18.02.2008
 * @author Henri Schmidhuber  info@in-solution.de
 * @copyright 2007 - 2008 Henri Schmidhuber
 * @link http://www.in-solution.de
 * @link http://www.oscommerce.com
 * @link https://ipayment.de
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 ***********************************************************************************
 * this file contains code based on:
 * (c) 2000 - 2001 The Exchange Project
 * (c) 2001 - 2008 osCommerce, Open Source E-Commerce Solutions
 * Released under the GNU General Public License
 ***********************************************************************************
 *
 */

  chdir('../../../../');
  require ('includes/application_top.php');

  if (!empty($HTTP_POST_VARS['shop_lang'])) {
    include(DIR_WS_LANGUAGES . $HTTP_POST_VARS['shop_lang'] . '/modules/payment/ipayment_elv.php');
  }

  include(DIR_WS_LANGUAGES . $language . '/modules/payment/ipayment_elv.php');

  $order_id = $betrag_integer = '';

  if (isset($HTTP_POST_VARS['shopper_id'])) {
    $order_id = substr($HTTP_POST_VARS['shopper_id'], strpos($HTTP_POST_VARS['shopper_id'], '-')+1);
  }

  if (isset($HTTP_POST_VARS['trx_amount'])) {
    $betrag_integer = $HTTP_POST_VARS['trx_amount'];
  }

  // Check if Order exists
  if (empty($order_id) || empty($betrag_integer)) {
    exit();
  }

  // check if order exists
  $order_query = tep_db_query("select * from " . TABLE_ORDERS . " where orders_id = '" . (int)$order_id . "' ");
  if (tep_db_num_rows($order_query) > 0) {
    $order = tep_db_fetch_array($order_query);

    if ($order['orders_status'] == MODULE_PAYMENT_IPAYMENT_ELV_PREPARE_ORDER_STATUS_ID) {
      $total_query = tep_db_query("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" .  (int)$order_id . "' and class = 'ot_total' limit 1");
      $total = tep_db_fetch_array($total_query);

      $order_total_integer = number_format($total['value'] * $currencies->get_value('EUR') * 100, 0, '','') ;
      $order_confirmed = false;

      $HTTP_POST_VARS['ipayment_confirmation'] = '';
      if ((int)$betrag_integer == (int)$order_total_integer) {
        $order_confirmed = true;
        $HTTP_POST_VARS['ipayment_confirmation'] .= '01 - ' . MODULE_PAYMENT_IPAYMENT_ELV_TEXT_CONFIRMED_BY_HIDDEN_TRIGER. "\n";
      } else {
        $order_confirmed = false;
        $HTTP_POST_VARS['ipayment_confirmation'] .= '11 - ' . MODULE_PAYMENT_IPAYMENT_ELV_TEXT_HIDDEN_TRIGER_ERROR_AMOUNT . ($betrag_integer/100) . '!=' . ($order_total_integer/100) . "\n";
      }

      if (tep_not_null(MODULE_PAYMENT_IPAYMENT_ELV_SECRET_HASH_PASSWORD) && $HTTP_POST_VARS['ret_param_checksum'] != md5(MODULE_PAYMENT_IPAYMENT_ELV_USER_ID . $order_total_integer . 'EUR'  . $HTTP_POST_VARS['ret_authcode'] . $HTTP_POST_VARS['ret_booknr'] . MODULE_PAYMENT_IPAYMENT_ELV_SECRET_HASH_PASSWORD)) {
        $order_confirmed = false;
        $HTTP_POST_VARS['ipayment_confirmation'] .= '12 - ' . MODULE_PAYMENT_IPAYMENT_ELV_TEXT_HIDDEN_TRIGER_ERROR_HASH . "\n";
      }

      if (!tep_not_null(MODULE_PAYMENT_IPAYMENT_ELV_SECRET_HASH_PASSWORD)) {
        $HTTP_POST_VARS['ipayment_confirmation'] .= '13 - ' . MODULE_PAYMENT_IPAYMENT_ELV_TEXT_MISSING_HIDDEN_TRIGER . "\n";
      }

      // check IP-Adressses
      $ipaddress= tep_get_ip_address();
      switch ($ipaddress) {
        case  '212.227.34.218':
        case  '212.227.34.220':
        case  '212.227.34.219':
          break;
        default:
          $order_confirmed = false;
          $HTTP_POST_VARS['ipayment_confirmation'] .= '13 - ' . MODULE_PAYMENT_IPAYMENT_ELV_TEXT_IP_ADDRESS_ERROR . "\n";
          break;
      }

      $order_status = $order['orders_status'];
      if ($order_confirmed == true) {
        $order_status = ( (MODULE_PAYMENT_IPAYMENT_ELV_ORDER_STATUS_ID > 0) ? (int)MODULE_PAYMENT_IPAYMENT_ELV_ORDER_STATUS_ID : (int)DEFAULT_ORDERS_STATUS_ID);
      }

      $sql_data_array = array('orders_id' => (int)$order_id,
                              'orders_status_id' => $order_status,
                              'date_added' => 'now()',
                              'customer_notified' => '0',
                              'comments' => '');

      tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

      $ipayment_transaktions_details = serialize($HTTP_POST_VARS);
      tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $order_status . "', last_modified = now(), ipayment_transaktions_details = '" . tep_db_input($ipayment_transaktions_details) . "' where orders_id = '" . (int)$order_id . "'");
    }
  }
exit();
?>