<?php
/**
 *
 *
 * @version ipayment 2.0  18.02.2008
 * @author Henri Schmidhuber  info@in-solution.de
 * @copyright 2007 - 2008 Henri Schmidhuber
 * @link http://www.in-solution.de
 * @link http://www.oscommerce.com
 * @link https://ipayment.de
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 ***********************************************************************************
 * this file contains code based on:
 * (c) 2000 - 2001 The Exchange Project
 * (c) 2001 - 2008 osCommerce, Open Source E-Commerce Solutions
 * Released under the GNU General Public License
 ***********************************************************************************
 *
 */

  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_TITLE', 'iPayment banktransfer');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_PUBLIC_TITLE', 'Banktransfer');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_DESCRIPTION', '<img src="images/icon_popup.gif" border="0">&nbsp;<a href="https://ipayment.de" style="text-decoration: underline; font-weight: bold;">Visit iPayment Website</a>');
  define('IPAYMENT_ERROR_HEADING', 'There has been an error processing your bank details');
  define('IPAYMENT_ERROR_MESSAGE', 'Please check your bank details!');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_BANK_ACCOUNT_OWNER', 'Bankowner');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_BANK_CODE', 'Bankcode:');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_BANK_ACCOUNTNUMBER', 'Bank accountnumber:');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_BANK_NAME', 'Bankname:');

 // following placeholders may be used for the invoice text:
 // {{order_id}}
 // {{order_date}}
 // {{customer_id}}
 // {{customer_name}}
 // {{customer_company}}
 // {{customer_email}}

  define('MODULE_PAYMENT_IPAYMENT_ELV_INVOICE_TEXT', 'Nr. {{order_id}} ' . STORE_NAME); // max 27 chars, depends on gateway
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_CONFIRMED_BY_REDIRECT','Payment confirmed by ipayment redirect!');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_ERROR_AMOUNT', 'ipayment transaktionscheck failed. Submitted amount doesn\'t match. Please check manually!');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_ERROR_SUSPICIOUS', 'Payment suspicious' . "\n" . 'Hidden Trigger Response:');

  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_CONFIRMED_BY_HIDDEN_TRIGER','Payment confirmed by ipayment hidden trigger script');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_HIDDEN_TRIGER_ERROR_AMOUNT', 'ipayment hidden trigger check failed: Submitted amount doesn\'t match. Please check manually!');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_HIDDEN_TRIGER_ERROR_HASH', 'ipayment hidden trigger check failed! checksum mismatch! Please check manually');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_MISSING_HIDDEN_TRIGER', 'Warning: Transaktions-security-key is not set!  Please check manually');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_IP_ADDRESS_ERROR', 'ipayment hidden trigger check failed: Calling ipayment IP-Addresse is wrong!  Please check manually');

  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_BANK_COUNTRY', 'Bankcountry:');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_GERMANY', 'Germany');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_AUSTRIA', 'Austria');

  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_TITLE_AUSTRIA', 'Banktransfer from austria account');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_TITLE_GERMANY', 'Banktransfer from german account');
  define('MODULE_PAYMENT_IPAYMENT_ELV_TEXT_TITLE_AUSTRIA_GERMANY', 'Banktransfer from austria or german account ');

?>